#
# Copyright (C)2022 @BABOLO http://www.babolo.ru/
# pkg = lrwi-textcase
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: levl.pleaf.m4,v 1.3 2022/10/09 02:22:11 babolo Exp $
#
#   

eval
#perform 0002
CREATE TEMP TABLE SQNM(g)(SQAT(i) int, SQAT(n) text, SQAT(g) text) STRICT;
#getget  _
#copyin  00_2
COPY SQNM(g) FROM stdin;
#wait
#close   _0_
#perform 0002
DELETE FROM SQNM(g) WHERE SQAT(i) > 1 AND SQAT(n) == '1';
#perform 0002
CREATE TEMP TABLE SQNM(y)(SQAT(a) int, SQAT(v) int) STRICT;
#perform 0002
INSERT INTO SQNM(y)
 SELECT DISTINCT CAST(SQAT(n) AS INTEGER), CAST(SQAT(g) AS INTEGER)
  FROM SQNM(g)
  WHERE (SQAT(n) REGEXP '^[0-9]+$') AND (SQAT(g) REGEXP '^[0-9]+$') AND SQAT(i) > 0
;
#select  _002
SELECT DISTINCT SQNM(vale).SQAT(name)
 FROM SQNM(vale) JOIN SQNM(y) ON(SQNM(vale).SQAT(vale) == SQNM(y).SQAT(v))
 WHERE SQNM(vale).SQAT(attr) == 1
   AND SQNM(y).SQAT(a) == 1
ORDER BY SQNM(y).SQAT(v)
;
#style   00y00_
levH
#display 00_00_
#close   _0_00_
#select  _002
WITH t AS(SELECT DISTINCT SQNM(listvale).SQAT(attr) AS SQAT(attr)
                        , SQNM(listvale).SQAT(vale) AS SQAT(vale)
                        , SQNM(listvale).SQAT(ordr) AS SQAT(ordr)
           FROM SQNM(listvale)
            JOIN SQNM(y) ON(   SQNM(listvale).SQAT(attr) == SQNM(y).SQAT(a)
                           AND SQNM(listvale).SQAT(vale) == SQNM(y).SQAT(v)
                           )
           WHERE SQNM(y).SQAT(a) <> 1
         )
   , a AS(SELECT t.SQAT(attr) AS SQAT(attr), MIN(t.SQAT(ordr)) AS SQAT(ordr)
           FROM t
          GROUP BY t.SQAT(attr)
         )
   , m AS(SELECT SQAT(attr) AS SQAT(attr), MIN(SQAT(vale)) AS SQAT(vale)
           FROM t JOIN a USING(SQAT(attr))
           WHERE t.SQAT(ordr) IS a.SQAT(ordr)
          GROUP BY SQAT(attr)
         )
   , b AS(SELECT t.SQAT(attr) AS SQAT(attr), MAX(t.SQAT(ordr)) AS SQAT(ordr)
           FROM t
          GROUP BY t.SQAT(attr)
         )
   , w AS(SELECT SQAT(attr) AS SQAT(attr), MAX(SQAT(vale)) AS SQAT(vale)
           FROM t JOIN b USING(SQAT(attr))
           WHERE t.SQAT(ordr) IS b.SQAT(ordr)
          GROUP BY SQAT(attr)
         )
SELECT CASE WHEN m.SQAT(vale) IS NOT NULL THEN SQNM(attr).SQAT(name) END AS hdr
     , SQNM(listvale).SQAT(name)                                        AS name
     , CASE WHEN w.SQAT(vale) IS NOT NULL THEN '' END                  AS ftr
 FROM       SQNM(attr)
       JOIN t              USING(SQAT(attr))
       JOIN SQNM(listvale) USING(SQAT(attr), SQAT(vale))
  LEFT JOIN m              USING(SQAT(attr), SQAT(vale))
  LEFT JOIN w              USING(SQAT(attr), SQAT(vale))
ORDER BY t.SQAT(attr), t.SQAT(ordr), t.SQAT(vale)
;
#style   00y00_
levh
#display 00_00_
#close   _0_00_
#select  100_
SELECT CINM(x).CIAT(sess)  AS sess
     , CINM(pnode).CIAT(p) AS page
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(m) == 'PKG' AND CINM(pnode).CIAT(v) == 'text'
;
#select  _012
WITH t AS(SELECT DISTINCT SQNM(listattr).SQAT(text) AS SQAT(text)
                        , SQNM(listattr).SQAT(attr) AS SQAT(attr)
           FROM SQNM(listattr)
            JOIN SQNM(y) ON(   SQNM(listattr).SQAT(attr) == SQNM(y).SQAT(a)
                           AND SQNM(listattr).SQAT(vale) == SQNM(y).SQAT(v)
         )                 )
   , z AS(SELECT COUNT(1) AS z FROM(SELECT DISTINCT SQNM(y).SQAT(a) FROM SQNM(y)))
   , c AS(SELECT COUNT(1) AS z, SQAT(text) AS SQAT(text) FROM t GROUP BY SQAT(text))
SELECT ?                     AS sess
     , ?                      AS page
     , SQNM(text).SQAT(text)   AS text
     , SQNM(text).SQAT(head)    AS head
     , SQNM(fullattr).SQAT(attr) AS attr
 FROM z JOIN c USING(z) JOIN SQNM(text) USING(SQAT(text)) LEFT JOIN SQNM(fullattr) USING(SQAT(text))
 ORDER BY SQNM(text).SQAT(ordr)
;
#style   00y00_
levl
#display 00_00_
#close   _0_00_
#select  100_
SELECT CINM(e).CIAT(e) FROM CINM(e) WHERE CINM(e).CIAT(n) == 'QUERY_STRING' LIMIT 1;
#select  _012
WITH p AS(SELECT DISTINCT SQNM(listattr).SQAT(attr)    AS SQAT(attr)
                        , SQNM(listattr).SQAT(vale)     AS SQAT(vale)
                        , MIN(SQNM(listattr).SQAT(ordr)) AS SQAT(ordr)
           FROM SQNM(listattr)
            JOIN SQNM(text) USING(SQAT(text))
            JOIN SQNM(y) ON(SQNM(text).SQAT(levl) == SQNM(y).SQAT(v) AND SQNM(y).SQAT(a) == 1)
           WHERE SQNM(listattr).SQAT(attr) <> 1
          GROUP BY SQNM(listattr).SQAT(attr), SQNM(listattr).SQAT(vale)
         )
   , t AS(SELECT DISTINCT p.SQAT(attr) AS SQAT(attr)
                        , p.SQAT(vale) AS SQAT(vale)
                        , p.SQAT(ordr) AS SQAT(ordr)
           FROM       p
            LEFT JOIN SQNM(y) ON(p.SQAT(attr) == SQNM(y).SQAT(a) AND p.SQAT(vale) == SQNM(y).SQAT(v))
           WHERE SQNM(y).SQAT(v) IS NULL
         )
   , a AS(SELECT t.SQAT(attr) AS SQAT(attr), MIN(t.SQAT(ordr)) AS SQAT(ordr)
           FROM t
          GROUP BY t.SQAT(attr)
         )
   , m AS(SELECT SQAT(attr) AS SQAT(attr), MIN(SQAT(vale)) AS SQAT(vale)
           FROM t JOIN a USING(SQAT(attr))
           WHERE t.SQAT(ordr) IS a.SQAT(ordr)
          GROUP BY SQAT(attr)
         )
SELECT CASE WHEN m.SQAT(vale) IS NOT NULL THEN SQNM(attr).SQAT(nome) END AS hdr
     , ?                                                                AS link
     , t.SQAT(attr)                                                    AS attr
     , t.SQAT(vale)                                                   AS vale
     , SQNM(listvale).SQAT(name)                                     AS name
 FROM       SQNM(attr)
       JOIN t              USING(SQAT(attr))
       JOIN SQNM(listvale) USING(SQAT(attr), SQAT(vale))
  LEFT JOIN m              USING(SQAT(attr), SQAT(vale))
ORDER BY t.SQAT(attr), t.SQAT(ordr), t.SQAT(vale)
;
#style   00y00_
sele
#display 00_00_
#close   _0_00_
#close   101
